
/********************************** (C) COPYRIGHT *******************************
* File Name          :CompatibilityHID.C
* Author             : WCH
* Version            : V1.2
* Date               : 2018/02/28
* Description        : CH554ģHID豸֧ж´ֿ֧ƶ˵´֧ȫ٣ 
*******************************************************************************/

#include "./Public/CH554.H"
#include "./Public/Debug.H"
#include "DataFlash.H"
#include <stdio.h>
#include <string.h>

//#define Fullspeed               1

#ifdef  Fullspeed
#define THIS_ENDP0_SIZE         64
#else
#define THIS_ENDP0_SIZE         8                                                  //USBжϴ䡢ƴΪ8
#endif

#define ENDP1_IN_SIZE 			64
#define ENDP2_IN_SIZE 			64

//UINT8X  Ep0Buffer[8>(THIS_ENDP0_SIZE+2)?8:(THIS_ENDP0_SIZE+2)] _at_ 0x0000;        //˵0 OUT&INżַ
//UINT8X  Ep2Buffer[128>(2*MAX_PACKET_SIZE+4)?128:(2*MAX_PACKET_SIZE+4)] _at_ 0x0044;//˵2 IN&OUT,żַ

UINT8X  Ep0Buffer[THIS_ENDP0_SIZE] _at_ 0x0000;                                //˵0 OUT&INżַ
UINT8X  Ep1Buffer[MAX_PACKET_SIZE] _at_ 0x0008;                                //˵1 IN,żַ
UINT8X  Ep2Buffer[2*MAX_PACKET_SIZE] _at_ 0x0050;                                //˵2 OUT,żַ

UINT8   SetupReq,SetupLen,Ready,Count,FLAG,UsbConfig;
PUINT8  pDescr;                                                                    //USBñ־
USB_SETUP_REQ   SetupReqBuf;                                                       //ݴSetup
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)  
#define DEBUG 0
#define DATA_FLASH_ADDR_Offset  0         //DATAFLASHƫƵַ
UINT8 DATAFLASH_data[27];

sbit Ep2InKey = P1^5;
sbit ComboKey1 = P3^2;                                                              //K1
sbit ComboKey2 = P3^3;                                                              //K2
sbit ComboKey3 = P3^4;                                                              //K3

#pragma  NOAREGS
/*豸*/
UINT8C DevDesc[18] = {0x12,0x01,0x00,0x01,0x00,0x00,0x00,THIS_ENDP0_SIZE,
                      0x89,0x11,0x90,0x88,0x00,0x01,0x01,0x02,
                      0x03,0x01
                     };
//UINT8C CfgDesc[41] =
//{
//    0x09,0x02,0x29,0x00,0x01,0x01,0x04,0xA0,0x23,               //
//    0x09,0x04,0x00,0x00,0x02,0x03,0x00,0x00,0x05,               //ӿ
//    0x09,0x21,0x00,0x01,0x00,0x01,0x22,0x22,0x00,               //HID
//#ifdef  Fullspeed	
//    0x07,0x05,0x82,0x03,THIS_ENDP0_SIZE,0x00,0x01,              //˵(ȫټʱĳ1ms)
//    0x07,0x05,0x02,0x03,THIS_ENDP0_SIZE,0x00,0x01,              //˵
//#else
//    0x07,0x05,0x82,0x03,THIS_ENDP0_SIZE,0x00,0x0A,              //˵(ټʱС10ms)
//    0x07,0x05,0x02,0x03,THIS_ENDP0_SIZE,0x00,0x0A,              //˵
//#endif	
//};

										 
/*ַ */ 

/*̱*/
UINT8C KeyRepDesc[] =
{
//ÿпʼĵһֽΪĿǰ׺ǰ׺ĸʽΪ
 //D7~D4bTagD3~D2bTypeD1~D0bSize·ֱÿĿע͡

/************************USBֱ̲**********************/
/*******************************************************************/
 //һȫ֣bTypeΪ1Ŀ;ҳѡΪͨGeneric Desktop Page(0x01)
 //һֽݣbSizeΪ1ֽͲעˣ
 //ԼbSizeжϡ
 0x05, 0x01, // USAGE_PAGE (Generic Desktop)

 //һֲbTypeΪ2Ŀ˵ļ;ڼ
 0x09, 0x06, // USAGE (Keyboard)

 //һĿbTypeΪ0Ŀϣ0x01ʾ
 //üһӦüϡǰ;ҳ;Ϊ
 //ͨõļ̡
 0xa1, 0x01, // COLLECTION (Application)

 //һȫĿѡ;ҳΪ̣Keyboard/Keypad(0x07)
 0x05, 0x07, //     USAGE_PAGE (Keyboard/Keypad)

 //һֲĿ˵;СֵΪ0xe0ʵǼCtrl
 //;ֵHID;в鿴
 0x19, 0xe0, //     USAGE_MINIMUM (Keyboard LeftControl)

 //һֲĿ˵;ֵΪ0xe7ʵǼGUI
 0x29, 0xe7, //     USAGE_MAXIMUM (Keyboard Right GUI)

 //һȫĿ˵صݵ߼ֵǷصֵ
 //СΪ0ΪBitʾһСΪ0Ϊ1
 0x15, 0x00, //     LOGICAL_MINIMUM (0)

 //һȫĿ˵߼ֵΪ1
 0x25, 0x01, //     LOGICAL_MAXIMUM (1)

 //һȫĿ˵Ϊ˸
 0x95, 0x08, //     REPORT_COUNT (8)

 //һȫĿ˵ÿĳΪ1bit
 0x75, 0x01, //     REPORT_SIZE (1)

 //һĿ˵8Ϊ1bitͳ
 //ǰȫĿ壩Ϊ룬
 //ΪData,Var,AbsDataʾЩݿԱ䶯Varʾ
 //ЩǶģÿʾһ˼Absʾֵ
 //ĽǣĳֵΪ1ʱͱʾӦļ¡
 //bit0ͶӦ;Сֵ0xe0bit7Ӧ;ֵ0xe7
 0x81, 0x02, //     INPUT (Data,Var,Abs)

 //һȫĿ˵Ϊ1
 0x95, 0x01, //     REPORT_COUNT (1)

 //һȫĿ˵ÿĳΪ8bit
 0x75, 0x08, //     REPORT_SIZE (8)

 //һĿãǰȫĿ֪Ϊ8bit
 //Ϊ1Ϊصһֱ0
 //ֽǱֽڣOEMʹã
 0x81, 0x03, //     INPUT (Cnst,Var,Abs)

 //һȫĿλΪ6
 0x95, 0x06, //   REPORT_COUNT (6)

 //һȫĿÿλ򳤶Ϊ8bit
 //ʵĿҪҲǿԵģΪǰѾһ
 //Ϊ8bitȫĿˡ
 0x75, 0x08, //   REPORT_SIZE (8)

 //һȫĿ߼СֵΪ0
 //ͬϣȫĿҲǿԲҪģΪǰѾһ
 //߼СֵΪ0ȫĿˡ
 0x15, 0x00, //   LOGICAL_MINIMUM (0)

 //һȫĿ߼ֵΪ255
 0x25, 0xFF, //   LOGICAL_MAXIMUM (255)

 //һȫĿѡ;ҳΪ̡
 //ǰѾѡ;ҳΪˣԸĿҪҲԡ
 0x05, 0x07, //   USAGE_PAGE (Keyboard/Keypad)

 //һֲĿ;СֵΪ00ʾûм£
 0x19, 0x00, //   USAGE_MINIMUM (Reserved (no event indicated))

 //һֲĿ;ֵΪ0x65
 0x29, 0x65, //   USAGE_MAXIMUM (Keyboard Application)

 //һĿ˵8bitõģ
 //ΪData,Ary,AbsData˵ǿԱģAry˵
 //Щһ飬ÿ8bitԱʾĳֵ
 //µļ̫ࣨ糬ﶨĳȻ߼̱޷
 //ɨʱЩݷȫ1ƣʾЧ
 //AbsʾЩֵǾֵ
 0x81, 0x00, //     INPUT (Data,Ary,Abs)

 //Ϊ
 //߼СֵǰѾжΪ0ˣʡԡ
 //һȫĿ˵߼ֵΪ1
 0x25, 0x01, //     LOGICAL_MAXIMUM (1)

 //һȫĿ˵Ϊ5
 0x95, 0x05, //   REPORT_COUNT (5)

 //һȫĿ˵ĳΪ1bit
 0x75, 0x01, //   REPORT_SIZE (1)

 //һȫĿ˵ʹõ;ҳΪָʾƣLED
 0x05, 0x08, //   USAGE_PAGE (LEDs)

 //һֲĿ˵;СֵΪ̵ּơ
 0x19, 0x01, //   USAGE_MINIMUM (Num Lock)

 //һֲĿ˵;ֵΪKanaơ
 0x29, 0x05, //   USAGE_MAXIMUM (Kana)

 //һĿݣǰ涨5LED
 0x91, 0x02, //   OUTPUT (Data,Var,Abs)

 //һȫĿλΪ1
 0x95, 0x01, //   REPORT_COUNT (1)

 //һȫĿλ򳤶Ϊ3bit
 0x75, 0x03, //   REPORT_SIZE (3)

 //һĿǰ5bitҪ
 //3bitճһֽڡ
 0x91, 0x03, //   OUTPUT (Cnst,Var,Abs)

 //ĿرǰļϡbSizeΪ0Ժûݡ
 0xc0,        // END_COLLECTION
};

/**/
//UINT8 HIDKey[8] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};


/*HID౨*/
UINT8C  HIDRepDesc[]={
	                        0x05,0x01,      //Desktop                                    //ÿĿռһ
												  0x09,0x00,//no
												  0xa1,0x01,//start
												  0x15,0x00,//local-min 00
												  0x25,0xff,//max-FF
												  0x19,0x01,//usagenum1-8
												  0x29,0x08,
												  0x95,0x08,
												  0x75,0x08,//8*8
											 	  0x81,0x02,//in(var)
												  0x09,0x02,//mouse
												  0x15,0x00,//local:00-FF
												  0x25,0xff,
                          0x75,0x08,
                          0x95,0x40,//8*64
                          0x91,0x06,	//out(var,rel)
												  0xc0
                          };

UINT8C CfgDesc[] =
{
    0x09, 0x02, 0x42, 0x00, 0x02, 0x01, 0x00, 0xA0, 0x32,             //
    0x09, 0x04, 0x00, 0x00, 0x01, 0x03, 0x01, 0x01, 0x00,             //ӿ,
    0x09, 0x21, 0x00, 0x01, 0x21, 0x01, 0x22, sizeof(KeyRepDesc), 0x00,             //HID
    0x07, 0x05, 0x81, 0x03, 0x08, 0x00, 0x0A,                         //˵жϴ
	  0x09,0x04,0x01,0x00,0x02,0x03,0x00,0x00,0x00,             //ӿЭ
	  0x09,0x21,0x00,0x01,0x00,0x01,0x22,sizeof(HIDRepDesc),0x00,             //HID    
	  0x07,0x05,0x82,0x03,0x08,0x00,0x0a,                       //˵    
	  0x07,0x05,0x02,0x03,0x08,0x00,0x0a                       //˵ 	
};
				
UINT8C MyProductIDInfo[] = {0x0E,0x03,'k',0,'e',0,'y',0,'5',0,'5',0,'9',0};

/*  */
UINT8C MyLangDescr[ ] = { 0x04, 0x03, 0x09, 0x04 };

/* Ϣ */
UINT8C MyManuInfo[ ] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };

/* ƷϢ */
UINT8C MyProdInfo[ ] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '5', 0, '9', 0 };

// unsigned char  code LangDes[]={0x04,0x03,0x09,0x04};           //
// unsigned char  code SerDes[]={
//                           0x28,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//                           0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//                           0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x43,0x00,0x42,
//                           0x00,0x43,0x00,0x31,0x00,0x00,0x00,0x00,0x00,0x00
//                           };                                   //ַ

UINT8X UserEp2Buf[64];                                            //ûݶ
UINT8 Endp2Busy = 0;

/**/
UINT8 HIDKey[9] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x0};
UINT8 HIDKey1[9] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x0};
UINT8 HIDKey2[9] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x0};
UINT8 ChangeHIDKey[8] = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
UINT8 DataBuffer[27];


/*******************************************************************************
* Function Name  : USBDeviceInit()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceInit()
{
	IE_USB = 0;
	USB_CTRL = 0x00;                                                           // 趨USB豸ģʽ
	UDEV_CTRL = bUD_PD_DIS;                                                    // ֹDP/DM	
#ifndef Fullspeed
    UDEV_CTRL |= bUD_LOW_SPEED;                                                //ѡ1.5Mģʽ
    USB_CTRL |= bUC_LOW_SPEED;
#else
    UDEV_CTRL &= ~bUD_LOW_SPEED;                                               //ѡȫ12MģʽĬϷʽ
    USB_CTRL &= ~bUC_LOW_SPEED;
#endif
    UEP2_DMA = Ep2Buffer;                                                      //˵2ݴַ
    UEP2_3_MOD |= bUEP2_TX_EN | bUEP2_RX_EN;                                   //˵2ͽʹ
    UEP2_3_MOD &= ~bUEP2_BUF_MOD;                                              //˵2շ64ֽڻ
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK;                 //˵2Զתͬ־λIN񷵻NAKOUTACK
    UEP0_DMA = Ep0Buffer;                                                      //˵0ݴַ
    UEP4_1_MOD &= ~(bUEP4_RX_EN | bUEP4_TX_EN);                                //˵064ֽշ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK
	
		UEP1_DMA = Ep1Buffer;                                                      //˵1ݴַ
    UEP4_1_MOD = UEP4_1_MOD & ~bUEP1_BUF_MOD | bUEP1_TX_EN;                    //˵1ʹ 64ֽڻ
		UEP4_1_MOD &= ~bUEP1_RX_EN;
		UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK;                                 //˵1Զתͬ־λIN񷵻NAK
		
	USB_DEV_AD = 0x00;
	USB_CTRL |= bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;                     // USB豸DMAжڼжϱ־δǰԶNAK
	UDEV_CTRL |= bUD_PORT_EN;                                                  // USB˿
	USB_INT_FG = 0xFF;                                                         // жϱ־
	USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
	IE_USB = 1;
}


/*******************************************************************************
* Function Name  : Enp1IntIn()
* Description    : USB豸ģʽ˵1жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void enp1IntIn( PUINT8 HIDKeyBuf )
{
    memcpy( Ep1Buffer, HIDKeyBuf, 8);                           //ϴ
    UEP1_T_LEN = 8;                                             //ϴݳ
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                //ʱϴݲӦACK
}


/*******************************************************************************
* Function Name  : Enp2BlukIn()
* Description    : USB豸ģʽ˵2ϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp2BlukIn( )
{
    memcpy( Ep2Buffer+MAX_PACKET_SIZE, UserEp2Buf, sizeof(UserEp2Buf));        //ϴ
    UEP2_T_LEN = THIS_ENDP0_SIZE;                                              //ϴ
    UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                  //ʱϴݲӦACK
}

/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH559USBжϴ
*******************************************************************************/
void    DeviceInterrupt( void ) interrupt INT_NO_USB using 1                    //USBжϷ,ʹüĴ1
{
    UINT8 len,i;
    if(UIF_TRANSFER)                                                            //USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ˵ϴ
            UEP2_T_LEN = 0;                                                    //Ԥʹ÷ͳһҪ
//            UEP1_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            Endp2Busy = 0 ;
			UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            break;
        case UIS_TOKEN_OUT | 2:                                                 //endpoint 2# ˵´
            if ( U_TOG_OK )                                                     // ͬݰ
            {			
                  UEP2_CTRL &= ~UEP_R_RES_ACK;	
                  UEP2_CTRL |= UEP_R_RES_NAK;									
                len = USB_RX_LEN;                                               //ݳȣݴEp2Buffer׵ַʼ		
                if(Ep2Buffer[0] == 1){//K1
                   memcpy(HIDKey, Ep2Buffer, 8);		
                   memcpy(DataBuffer,HIDKey,8);		
#if DEBUG
for(len=0;len<27;len++){
printf("%02x  ",(UINT16)DataBuffer[len]);
}	
#endif									
                }
                else if(Ep2Buffer[0] == 2){//K2
                   memcpy(HIDKey1, Ep2Buffer, 8);		
                   memcpy(DataBuffer+9,HIDKey1,8);		
#if DEBUG
for(len=0;len<27;len++){
printf("%02x  ",(UINT16)DataBuffer[len]);
}	
for(len=0;len<27;len++){
	printf("-%02x  ",(UINT16)*(Ep2Buffer+len));
}	
#endif											
                }
                else if(Ep2Buffer[0] == 3){//K3
                   memcpy(HIDKey2, Ep2Buffer, 8);		
                   memcpy(DataBuffer+18,HIDKey2,8);		
#if DEBUG
for(len=0;len<27;len++){
printf("%02x  ",(UINT16)DataBuffer[len]);
}	
#endif										
                }
                else{}																								
            }		
            UEP2_CTRL &= ~UEP_R_RES_NAK;	
            UEP2_CTRL |= UEP_R_RES_ACK;	
            break;
						//ж
						case UIS_TOKEN_IN | 1:                                                  //endpoint 1# ж϶˵ϴ
            UEP1_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
//            UEP1_CTRL ^= bUEP_T_TOG;                                            //ֶתͬ־λ
            UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            if(FLAG&1) FLAG++;                                                        /*ɱ־*/
            break;		
        case UIS_TOKEN_SETUP | 0:                                               //SETUP
            len = USB_RX_LEN;
            if(len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthL;
                len = 0;                                                         // ĬΪɹϴ0
                SetupReq = UsbSetupBuf->bRequest;							
                if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )/*HID*/
                {
					switch( SetupReq )                                             
					{
						case 0x01:                                                  //GetReport
							pDescr = UserEp2Buf;                                    //ƶ˵ϴ
							if(SetupLen >= THIS_ENDP0_SIZE)                         //ڶ˵0СҪ⴦
							{
								len = THIS_ENDP0_SIZE;
							}													 
							else
							{													 
								len = SetupLen;              											
							}													 
							break;
						case 0x02:                                                   //GetIdle
							break;	
						case 0x03:                                                   //GetProtocol
							break;				
						case 0x09:                                                   //SetReport										
							break; 
						case 0x0A:                                                   //SetIdle
							break;	
						case 0x0B:                                                   //SetProtocol
							break;
						default:
							len = 0xFF;  				                              /*֧*/					
							break;
					}	
					if( SetupLen > len )
					{
						SetupLen = len;    //ܳ
					}
					len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;   //δ䳤
					memcpy(Ep0Buffer,pDescr,len);                                     //ϴ
					SetupLen -= len;
					pDescr += len;									
                }
                else                                                             //׼
                {
                    switch(SetupReq)                                             //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch(UsbSetupBuf->wValueH)
                        {
                        case 1:                                                  //豸
                            pDescr = DevDesc;                                    //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case 2:                                                  //
                            pDescr = CfgDesc;                                    //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
												case 3:                                            // ַ
                        switch( UsbSetupBuf->wValueL )
                        {
                          case 1:
                                pDescr = (PUINT8)( &MyManuInfo[0] );       
                                len = sizeof( MyManuInfo );
                                break;
                          case 2:
                                pDescr = (PUINT8)( &MyProdInfo[0] );        
                                len = sizeof( MyProdInfo );
                                break;
                          case 0:
                                pDescr = (PUINT8)( &MyLangDescr[0] );
                                len = sizeof( MyLangDescr );
                                break;
                          case 3:
                                pDescr = (PUINT8)( &MyProductIDInfo[0] );
                                len = sizeof( MyProductIDInfo );
                                break;													
                          default:
                                len = 0xFF;                                 // ֵַ֧
                                break;
						            }
                        break;
                        case 0x22:                                               //
													if(UsbSetupBuf->wIndexL == 0)                   //ӿ0
                            {
                                pDescr = KeyRepDesc;                        //׼ϴ
                                len = sizeof(KeyRepDesc);
                            }
														else if(UsbSetupBuf->wIndexL == 1)              //ӿ1
                            {
                                pDescr = HIDRepDesc;                         //׼ϴ
																len = sizeof(HIDRepDesc);                                
                            }
                            else
                            {
                                len = 0xff;                                 //ֻ2ӿڣ仰ִ
                            }                           
                            break;
                        default:
                            len = 0xff;                                          //ֵ֧߳
                            break;
                        }
                        if ( SetupLen > len )
                        {
                            SetupLen = len;    //ܳ
                        }
                        len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;//δ䳤
                        memcpy(Ep0Buffer,pDescr,len);                            //ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;                         //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if ( SetupLen >= 1 )
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
						if(UsbConfig)
						{
							Ready = 1;                                            //set configһusböɵı־
						}
                        break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                      //Clear Feature
                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                        {
                            switch( UsbSetupBuf->wIndexL )
                            {
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x02:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                break;
                            default:
                                len = 0xFF;                                       // ֵ֧Ķ˵
                                break;
                            }
                        }
                        else
                        {
                            len = 0xFF;                                           // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                                         /* Set Feature */
                        if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x00 )        /* 豸 */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x01 )
                            {
                                if( CfgDesc[ 7 ] & 0x20 )
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = 0xFF;                                    /* ʧ */
                                }
                            }
                            else
                            {
                                len = 0xFF;                                        /* ʧ */
                            }
                        }
                        else if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x02 )    /* ö˵ */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x00 )
                            {
                                switch( ( ( UINT16 )UsbSetupBuf->wIndexH << 8 ) | UsbSetupBuf->wIndexL )
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                                    break;
                                default:
                                    len = 0xFF;                                     /* ʧ */
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF;                                         /* ʧ */
                            }
                        }
                        else
                        {
                            len = 0xFF;                                             /* ʧ */
                        } 
                        break;
                    case USB_GET_STATUS:
                        Ep0Buffer[0] = 0x00;
                        Ep0Buffer[1] = 0x00;
                        if ( SetupLen >= 2 )
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = 0xff;                                                  //ʧ
                        break;
                    }
                }
            }
            else
            {
                len = 0xff;                                                          //ȴ
            }
            if(len == 0xff)
            {
                SetupReq = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
            }
            else if(len <= THIS_ENDP0_SIZE)                                         //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
            }
            else
            {
                UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
            }
            break;
        case UIS_TOKEN_IN | 0:                                                      //endpoint0 IN
            switch(SetupReq)
            {
            case USB_GET_DESCRIPTOR:
            case HID_GET_REPORT:							
                len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;     //δ䳤
                memcpy( Ep0Buffer, pDescr, len );                                   //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                                            //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                                      //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
            len = USB_RX_LEN;
            if(SetupReq == 0x09)
            {
                if(Ep0Buffer[0])
                {
                    printf("Light on Num Lock LED!\n");
                }
                else if(Ep0Buffer[0] == 0)
                {
                    printf("Light off Num Lock LED!\n");
                }
            }
            UEP0_CTRL ^= bUEP_R_TOG;                                     //ͬ־λת		
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                                           //д0ж
    }
    if(UIF_BUS_RST)                                                                 //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
		Endp2Busy = 0;
        UIF_BUS_RST = 0;                                                             //жϱ־
    }
    if (UIF_SUSPEND)                                                                 //USB߹/
    {
        UIF_SUSPEND = 0;
        if ( USB_MIS_ST & bUMS_SUSPEND )                                             //
        {
#ifdef DE_PRINTF
            printf( "zz" );                                                          //˯״̬
#endif
//             while ( XBUS_AUX & bUART0_TX )
//             {
//                 ;    //ȴ
//             }
//             SAFE_MOD = 0x55;
//             SAFE_MOD = 0xAA;
//             WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                                   //USBRXD0źʱɱ
//             PCON |= PD;                                                               //˯
//             SAFE_MOD = 0x55;
//             SAFE_MOD = 0xAA;
//             WAKE_CTRL = 0x00;
        }
    }
    else {                                                                             //ж,ܷ
        USB_INT_FG = 0xFF;                                                             //жϱ־
//      printf("UnknownInt  N");
    }
}


void HIDValueHandle()
{
    mDelaymS(2);                                                     //ʱⰴ
    if ((ComboKey1 == 0)&&(HIDKey[0] != 0xFF)){
        FLAG = 0x11;					
//ϴʾ A
//         HIDKey[0] = 0x00;                                                
//         HIDKey[2] = 0x3a;                                                //F1
        enp1IntIn(HIDKey+1);
    }
    else if ((ComboKey2 == 0)&&(HIDKey1[0] != 0xFF)){
        FLAG = 0x21;					
//ϴʾ A
//         HIDKey[0] = 0x00;                                                
//         HIDKey[2] = 0x3b;                                                //F2
        enp1IntIn(HIDKey1+1);
    }
    else if ((ComboKey3 == 0)&&(HIDKey2[0] != 0xFF)){
        FLAG = 0x31;					
//ϴʾ A
//         HIDKey[0] = 0x00;                                                
//         HIDKey[2] = 0x3c;                                                //F3
        enp1IntIn(HIDKey2+1);
    }		
    else{
        UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;        //ĬӦNAK
    }
}



main()
{
    UINT8 i,status;
    CfgFsys( );                                                           //CH559ʱѡ
    mDelaymS(5);                                                          //޸Ƶȴڲȶ,ؼ	
    mInitSTDIO( );                                                        //0ʼ 
#ifdef DE_PRINTF
    printf("start ...\n");
#endif	
	memset(DataBuffer,0x00,27);
	ReadDataFlash(DATA_FLASH_ADDR_Offset,27,DATAFLASH_data);
		if(DATAFLASH_data[2]==0 && DATAFLASH_data[0]==0xAA)
		{	
      for(i=0;i<9;i++){
				HIDKey[i] = DATAFLASH_data[i];
      }		
      memcpy(DataBuffer,HIDKey,9);			
    }
		if(DATAFLASH_data[9+2]==0 && DATAFLASH_data[9]==0xAA)
		{	
      for(i=0;i<9;i++){
				HIDKey1[i] = DATAFLASH_data[9+i];
      }		
      memcpy(DataBuffer+9,HIDKey1,9);			
    }
		if(DATAFLASH_data[18+2]==0 && DATAFLASH_data[18]==0xAA)
		{	
      for(i=0;i<9;i++){
				HIDKey2[i] = DATAFLASH_data[18+i];
      }		
      memcpy(DataBuffer+18,HIDKey2,9);			
    }
//    if((*((PUINT8C)(DATA_FLASH_ADDR+FLASHOFFECT+2))==0)&&(*((PUINT8C)(DATA_FLASH_ADDR+FLASHOFFECT))==0xAA))
//	  {	
//      for(i=0;i<9;i++){
//				HIDKey[i] = *((PUINT8C)(DATA_FLASH_ADDR+0+i));
//      }		
//      memcpy(DataBuffer,HIDKey,9);				
//    }
    for(i=0; i<64; i++)                                                   //׼ʾ
    {
        UserEp2Buf[i] = i;
    }
    USBDeviceInit();                                                      //USB豸ģʽʼ
    EA = 1;                                                               //Ƭж		
    UEP1_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    UEP2_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    FLAG = 0;
    Ready = 0;
    while(1)
    {
			if((Ready == 1)&&(FLAG == 0)&&((ComboKey1==0)||(ComboKey2==0)||(ComboKey3 == 0))){
            HIDValueHandle( );                                           //F1
// 					  printf("ComboKey1&ComboKey2= %02x, ComboKey3= %02x\n",(UINT16)(ComboKey1&ComboKey2),(UINT16)ComboKey3);
        }
        if(((FLAG==0x12)&&(ComboKey1 == 1))||((FLAG==0x22)&&ComboKey2)||((FLAG==0x32)&&ComboKey3)){//Ѿͷ
          FLAG = 0;					
          mDelaymS( 10 );                                                  //ƵϴҲɸ
          if(ComboKey1 || ComboKey2 || ComboKey3){
//             HIDKey[0] = 0;
//             HIDKey[2] = 0;                                                //
            enp1IntIn(ChangeHIDKey);						
          }
				}
        if((HIDKey[0] == 1)||(HIDKey1[0] == 2)||(HIDKey2[0] == 3)){
					if(HIDKey[0] == 1) HIDKey[0] = 0xAA;DataBuffer[0] = 0xAA;
					if(HIDKey1[0] == 2) HIDKey1[0] = 0xAA;DataBuffer[9] = 0xAA;		
					if(HIDKey2[0] == 3) HIDKey2[0] = 0xAA;DataBuffer[18] = 0xAA;	
				  i = 3;							
				  while(i--){
//					  status = EraseDataFlash(DATA_FLASH_ADDR);
//					  if(status != 0) continue;
#if DE_PRINTF					
					  printf("write ..\n");
#endif					
					  WriteDataFlash(DATA_FLASH_ADDR_Offset, DataBuffer, 27);
					  break;			  
				  }						
        }
//        if(Ready)
//        {
//            HIDValueHandle();                                             //úһֱȴڽһֽ
//        }
//			
//        if(Ready && (Ep2InKey==0))
//        {
//			while( Endp2Busy );                                            //æһûдȥȴ
//						Endp2Busy = 1;                                                 //Ϊæ״̬
//            Enp2BlukIn( );
//            mDelaymS( 100 );
//        }
//        mDelaymS( 100 );                                                 //ģⵥƬ
    }
}
