
/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/01/20
* Description        : CH554 DataFlashֽڶдʾʾ
                       д DataFlash Ŀַд뵥ֽ
                        DataFlash 򣬴Ŀַȡֽ		   									
*******************************************************************************/

#include "..\Public\CH554.H"                                                   
#include "..\Public\Debug.H"
#include "DataFlash.H"
#include "stdio.h"
#include <string.h>



/*******************************************************************************
* Function Name  : ProgWord
* Description    : оƬ̺
* Input          : Addr    оƬ̵ַַַΪżַ
                   Data    ݣWORDΪ׼
* Output         : None
* Return         :         оƬ̷״̬
                    0x00   ̳ɹ
                    0x01   ̳ʱ
                    0x02   δ֪󣬱ʧ
*******************************************************************************/
UINT8 ProgWord( UINT16 Addr, UINT16 Data )
{

	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	GLOBAL_CFG |= bCODE_WE;                                                   
  SAFE_MOD = 0;  
  
	ROM_ADDR = Addr;
//	ROM_BUF_MOD = bROM_BUF_BYTE;
	ROM_DATA = Data;
	if ( ROM_STATUS & bROM_ADDR_OK ) { 
		ROM_CTRL = 0x9a;
		return( ( ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F );  
	}
	else 
		return( 0x40 );
}



void main( ) 
{
    UINT8 i,m,len;
	const unsigned short code *p0;
	const unsigned short code *p1;
	const unsigned short code *p3;
	const unsigned short code *p4;
	
    UINT16 j = 0;
    CfgFsys( );                                                                //CH554ʱѡ   
    mDelaymS(20);
    mInitSTDIO( );                                                             //0ʼ
    printf("start ...\n"); 
	
	printf("CHIP_ID = %02x \n",(UINT16)CHIP_ID);
	p0 = 0x3FFC;
	p1 = 0x3FFE;
	printf("ID_ONLY = %04x-%04x \n",(UINT16)*p0,(UINT16)*p1);
    
	p3 = 0x3700;
	p4 = 0x3702;
	ProgWord(0x3700,0x1234);
	ProgWord(0x3702,0x5678);
	printf("read codeflash = %04x\n",(UINT16)*p3);
	printf("read codeflash = %04x\n",(UINT16)*p4);
	
    while(1){
      for(i=0;i<128;i++){	                                                     //ѭд128ֽ		
        len = WriteDataFlash(i,&i,1);                                          //DataFlashƫƵַiдi
        if(len != 1){
          printf("Write Err  = %02x,m = %02x\n",j,(UINT16)m);                //дӡ				
        }
      }
      for(i=0;i<128;i++){                                                      //DataFlashƫƵַiУ
        len = ReadDataFlash(i,1,&m);
        if((len != 1) ||(m != i)){
          printf("Read Err  = %02x, = %02x,addr =%02x ,ֵ= %02x\n",j,(UINT16)(i*2),(UINT16)ROM_DATA_L,(UINT16)m);				
        }                                                                      //Уӡ
      }  
      printf("$$OK %02x \n",j);			
      j++;
      mDelaymS(100);			
    }
}